<?php

/*
   This program generates a listing of current local dates and times
   around the world.

   Author  : Jay Tanner
   License : Public Domain
*/



// ------------------------------------------------------------------
// GENERATE INDEXED TEXT LISTING OF ALL DEFINED TIME ZONE IDENTIFIERS
// AND CURRENT DATES AND TIMES IN ALL DEFINED ZONES.

   $TimeZonesList = trim(Time_Zones_ID_List());

   print
"<pre style='font-size:150%; font-weight:bold; line-height:125%;'>
=================================================================
          CURRENT WORLD TIMES LISTING AT 426 LOCATIONS
                    PHP Program by Jay Tanner

  Refresh This Page to Update the Listing to the Current Moment
=================================================================
   LOCAL DATE and TIME               GEOGRAPHIC LOCATION
=========================  ======================================
$TimeZonesList
























</pre>";




   function Time_Zones_ID_List()
{
// Get listing of all defined locales.
   $ListArray = DateTimeZone::ListIdentifiers();
   $ListCount = count($ListArray);

// Cycle through all defined locations.
   $LocalWorldTimesList = '';

   for ($i=0;  $i < $ListCount;  $i++)
  {
   $iii = SPrintF("% 3d", $i+1);
   $ZoneLocation = trim($ListArray[$i]);
   $ZoneDateTime = Current_Date_Time_At($ZoneLocation);
   $LocalWorldTimesList .= ("$ZoneDateTime\n");
  }

// Convert world times listing from text into work array
// and sort the work array into ascending order by date
// and time.
   $wArray = PReg_Split("[\n]", $LocalWorldTimesList);
   NatCaseSort($wArray);

// Convert work array contents back into text string.
   $LocalWorldTimesList = implode("\n", $wArray);

   return trim($LocalWorldTimesList);
}



/*
   ========================================================
   This function returns the local date and
   time given any defined location ID string.

   Example: LocationIDString = 'America/New_York'
   Returns: '2023-Feb-11-Sat  01:42:52  America/New_York'

   ========================================================
*/
   function Current_Date_Time_At ($LocationIDString='UTC')
{
   $ListArray = DateTimeZone::ListIdentifiers();
   $w = new DateTimeZone(trim($LocationIDString));
   $DateTimeAtLoc = new DateTime('now', $w);

// Extract raw date/time strings from OB.
   OB_Start();
   Var_Dump($DateTimeAtLoc);   $w = OB_Get_Contents();
   OB_End_Clean();

   $wArray  = PReg_Split("[ ]", $w);
   $DateStr = Str_Replace('"', '', trim($wArray[7]));
   $TimeStr = Str_Replace('"', '', trim($wArray[8]));
   $ss      = SPrintF("%02d", substr($TimeStr, -9));
   $TimeStr = substr($TimeStr,0,6).$ss;

// Perform calendrical computations for full date string.
   list($y,$m,$d)    = PReg_Split("[-]", $DateStr);
   $JDNum            = GregorianToJD(IntVal($m),IntVal($d),IntVal($y));
   $Mmm              = JDMonthName($JDNum, CAL_MONTH_GREGORIAN_SHORT);
   $DoW              = JDDayofWeek($JDNum, 2);
   $DateString       = "$y-$Mmm-$d-$DoW";
   $DateAndTime      = "$DateString  $TimeStr";
   $LocationIDString = substr($LocationIDString.Str_Repeat(' ',32),0,32);

   return "$DateAndTime  $LocationIDString";
}








?>



